image: 'rustlang/rust:nightly'

variables:
  CARGO_HOME: $CI_PROJECT_DIR/cargo

before_script:
  - apt-get update -yqq
  - apt-get install -yqq --no-install-recommends build-essential cmake git
  - apt-get install -yqq --no-install-recommends libzmq3-dev protobuf-compiler
  - git submodule sync --recursive
  - git submodule update --init --recursive
  - RUSTFLAGS="--cfg procmacro2_semver_exempt" cargo install cargo-tarpaulin

test:cargo:
  stage: test
  script:
    - rustc --version
    - cargo --version
    - cargo clean
    - cargo build
    - cargo test
  cache:
    paths:
      - cargo/
      - target/

after_script:
  - cargo tarpaulin --out Xml
  - bash <(curl -s https://codecov.io/bash)
  - echo "Uploaded code coverage"
